<?php
/*
Plugin Name: Google Sitemaps - Append UTW Tags
Plugin URI: http://www.dicontas.co.uk/blog/google-sitemap-utw-tag-wordpress-plugin/
Description: This plugin will automatically append the tags used by the Ultimate Warrior Tags plugin onto your Google XML Sitemap.  The Google (XML) Sitemaps plugin must also be installed.
Version: 2.0b
Author: Stewart Farquhar
Author URI: http://www.dicontas.co.uk/blog/
*/
?>
<?php
/*  Copyright 2007  Stewart Farquhar, Dicontas Limited  (email : stewart.farquhar@dicontas.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
?>
<?php

	function CheckForUTWInstall() {
		global $UTWinstalled_build;

		$UTWinstalled_build = get_option('utw_installed_build');
		if ($UTWinstalled_build == '') {
			$UTWinstalled_build = 0;
			echo '<h2>Errors Reported from the AddTagsToSitemap plugin</h2>';
			echo '<h3>Ultimate Tag Warrior - Configuration Errors</h3>';
			echo '<p>There is no installation of Ultimate Tag Warrior, please install this plugin as this is a requirement for this plugin to work.</p>';
		}

		if ($UTWinstalled_build != "7") {
			echo '<h3>Ultimate Tag Warrior - Configuration Errors</h3>';
			echo '<p>You need to upgrade the Ultimate Tag Warrior plugin to at least Version 3.14 for this plugin to work.</p>';
		}
		return $UTWinstalled_build;	 
	}


	function GetUTWTagUrl ($UTWtag_name, $UTWhome, $UTWbaseurl, $UTWuseprettyurls, $UTWtrailing){
		global $UTWtagurl;
		if ($UTWuseprettyurls == "yes") {
			$UTWtagurl = $UTWhome . $UTWbaseurl . $UTWtag_name . $trailing;
		} else {
			$UTWtagurl = $UTWhome . "/index.php?tag=" . $UTWtag_name;
		}
		return $UTWtagurl;
	}

	
	function GetUTWtags() {
		global $wpdb, $table_prefix, $UTWtabletags, $UTWtablepost2tag, $UTWsiteurl, $UTWbaseurl, $UTWhome, $UTWuseprettyurls, $UTWtrailing;;
		
		
		//get plugin variables
		$UTWtabletags = $table_prefix . "tags";
		$UTWtablepost2tag = $table_prefix . "post2tag";
		$UTWsiteurl = get_option('siteurl');
		$UTWhome = get_option('home');
		$UTWbaseurl = get_option('utw_base_url');
		if (get_option('utw_use_pretty_urls') == 'yes') $UTWuseprettyurls = "yes";
		$UTWtrailing = '';
		if (get_option('utw_trailing_slash') == 'yes') $UTWtrailing = "/";

		$UTWversion = CheckForUTWInstall();

		if ($UTWversion == "7") {
			$utwtagObject = &GoogleSitemapGenerator::GetInstance();
			$utwtags=array();
			$utwtags=$wpdb->get_results("SELECT tag FROM " . $UTWtabletags);
			if($utwtags) {
				foreach($utwtags as $utwtag) {
					$utw_tag = GetUTWTagUrl($utwtag->tag, $UTWhome, $UTWbaseurl, $UTWuseprettyurls, $UTWtrailing);
					
					//you can modify the sitemaps page refresh interval and priority to your own settings if you want to
					// valid refresh internal is "always", "hourly", "daily", "weekly", "monthly" or "yearly"
					// valid priority level is 0.1, 0.2 to 1.0 (1.0 being the highest)
					if($utwtagObject!=null) $utwtagObject->AddUrl($utw_tag,time(),"daily",0.6);
				}
			}
		}
	}

add_action("sm_buildmap","GetUTWtags");
?>